<!--模型压缩 -->
<template>
  <div style="position: relative">
    <div class="topBox">
      <div class="title">模型压缩</div>
      <div class="instructions">通过量化、稀疏化等方法在尽量减少精度损失的前提下，降低AI加速卡资源占用，提高推理速度。</div>
    </div>
    <div
      class="tableBox"
      :style="{ height: tableHeight }"
    >

      <el-form
        ref="myDataSetPage"
        :model="myDataSetPage"
        label-width="75px"
        :size="defaultFormItemSize"
        label-position="right"
        @submit.native.prevent
      >
        <filter-box
          :item-width="350"
          @search="refresh()"
          @reset="onReset"
        >
          <el-form-item label-width="0px">
            <el-button
              class="add"
              type="primary"
              icon="el-icon-plus"
              :size="defaultFormItemSize"
              @click="add()"
            >创建压缩任务</el-button>
          </el-form-item>
          <el-form-item
            label="任务名称"
            prop="formFilter.taskName"
            label-width="70px"
          >
            <el-input
              class="filter-item"
              v-model="myDataSetPage.formFilter.taskName"
              :clearable="true"
              placeholder="任务名称"
            />
          </el-form-item>
        </filter-box>
      </el-form>

      <vxe-table
        border
        show-header-overflow
        show-overflow
        :row-config="{ isHover: true }"
        :data="myDataSetPage.tableData.impl.dataList"
        min-height="96"
      >
        <vxe-column
          field="taskName"
          title="任务名称"
        ></vxe-column>
        <vxe-column
          field="taskStatus"
          title="任务状态"
        >
          <template slot-scope="scope">
            {{ TaskStatus.getValue(scope.row.taskStatus) }}
          </template>
        </vxe-column>
        <vxe-column
          field="sourceVersionId"
          title="源模型"
        >
          <template slot-scope="scope">
            {{ scope.row.modelTask?.versionName }}
          </template>
        </vxe-column>
        <vxe-column
          field="targetVersionId"
          title="压缩后模型"
        ></vxe-column>
        <vxe-column
          field="createTime"
          title="创建时间"
        ></vxe-column>
        <vxe-column
          field="operation"
          title="操作"
        >
          <template slot-scope="scope">
            <el-button
              type="text"
              :size="defaultFormItemSize"
              @click="particulars(scope.row)"
            >详情</el-button>
            <el-button
              type="text"
              :size="defaultFormItemSize"
              @click="copy(scope.row)"
            >复制</el-button>
            <el-button
              type="text"
              :size="defaultFormItemSize"
              @click="del(scope.row)"
            >删除</el-button>
          </template>
        </vxe-column>
      </vxe-table>
      <el-row
        slot="pagination"
        type="flex"
        justify="end"
        style="margin-top: 16px;"
      >
        <el-pagination
          :total="myDataSetPage.tableData.impl.totalCount"
          :current-page="myDataSetPage.tableData.impl.currentPage"
          :page-size="myDataSetPage.tableData.impl.pageSize"
          :page-sizes="[10, 20, 50, 100]"
          layout="total, prev, pager, next, sizes"
          @current-change="myDataSetPage.tableData.impl.onCurrentPageChange"
          @size-change="myDataSetPage.tableData.impl.onPageSizeChange"
        >
        </el-pagination>
      </el-row>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
/* eslint-disable-next-line */
import { TableWidget } from '@/utils/widget.js'
import { ModelCompress } from '@/api/gptController.js'
import editOrAdd from './dialog/editOrAdd'
import particulars from './dialog/particulars'
export default {
  data() {
    return {
      myDataSetPage: {
        formFilter: {
          taskName: ''
        },

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    }
  },

  components: {},

  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight() {
      return this.getMainContextHeight - 145 + 'px'
    }
  },

  methods: {
    getwidgetData(params) {
      if (params == null) params = {}
      params = {
        ...params,
        // orderParam: [
        //   {
        //     asc: true,
        //     dateAggregateBy: '',
        //     fieldName: ''
        //   }
        // ],
        // pageParam: {
        //   pageNum: 0,
        //   pageSize: 0
        // },
        modelCompressDtoFilter: { ...this.myDataSetPage.formFilter }
      }

      return new Promise((resolve, reject) => {
        ModelCompress.list(this, params)
          .then((res) => {
            resolve({
              dataList: res.data.dataList,
              totalCount: res.data.totalCount
            })
          })
          .catch((e) => {
            reject(e)
          })
      })
    },
    particulars(item) {
      this.$dialog
        .show(
          '详情',
          particulars,
          {
            area: ['100%', '100%']
          },
          { item: item }
        )
        .then((res) => {})
        .catch((e) => {})
    },
    add() {
      this.$dialog
        .show(
          '创建模版',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: false }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    copy(item) {
      this.$dialog
        .show(
          '复制任务',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          {
            isCopy: true,
            item: {
              createMethod: item.createMethod,
              sourceVersionId: item.sourceVersionId,
              targetModelId: item.targetModelId,
              taskDescribe: item.taskDescribe,
              taskName: item.taskName
            }
          }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    edit(item) {
      this.$dialog
        .show(
          '修改模版',
          editOrAdd,
          {
            area: ['100%', '100%']
          },
          { isEdit: true, item: item }
        )
        .then((res) => {
          this.refresh()
        })
        .catch((e) => {})
    },
    del(item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { taskId: item.taskId }
        ModelCompress.delete(this, params)
          .then((res) => {
            this.$message.success('删除成功')
            this.refresh()
          })
          .catch((e) => {
            console.log(e)
          })
      })
    },
    refresh(reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1)
      } else {
        this.myDataSetPage.tableData.impl.refreshTable()
      }
    },
    onReset() {
      this.$refs.myDataSetPage.resetFields()
      this.refresh(true)
    },
    formInit() {
      this.refresh()
    }
  },

  mounted() {
    this.formInit()
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/style/element-variables.scss';
.topBox {
  background-color: white;
  width: 100%;
  height: 95px;
  margin-bottom: 16px;
  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
    padding: 20px 20px 10px 20px;
  }
}
.instructions {
  padding: 0px 20px 20px 20px;

  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }
  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }
  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }
  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }
  .img {
    height: 72px;
    width: 140px;
  }
}
.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
</style>
